var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
export const defaultOptions = {
    waitingDuration: 100,
    maxExecution: 1,
};
export const wait = (duration) => new Promise((resolve) => setTimeout(resolve, duration));
export const makeAsyncLoop = (callback, options) => {
    const actualOptions = Object.assign(Object.assign({}, defaultOptions), options);
    let activeCount = 0;
    const execute = (currentParameters) => __awaiter(void 0, void 0, void 0, function* () {
        while (activeCount === actualOptions.maxExecution) {
            yield wait(actualOptions.waitingDuration);
        }
        activeCount++;
        const multiple = Array.isArray(currentParameters);
        const result = (yield multiple) ? callback(...currentParameters) : callback(currentParameters);
        activeCount--;
        return result;
    });
    return (...parameters) => __awaiter(void 0, void 0, void 0, function* () { return yield Promise.all(parameters.map(execute)); });
};
